/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.system.swing.filechooser;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import javax.swing.AbstractListModel;
import javax.swing.DefaultListModel;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.ListCellRenderer;
import javax.swing.ListSelectionModel;
import org.visnow.vn.system.config.FavoriteFolder;
import org.visnow.vn.system.main.VisNow;
import org.visnow.vn.system.swing.JComponentViewer;

/**
 *
 * @author gacek
 */
public class AddFavoriteFolderPanel extends javax.swing.JPanel
{

    //<editor-fold defaultstate="collapsed" desc=" [FSVAR] model ">
    //TODO: Czy to może być statyczne? Sprawdzić efekt dzielenia modelu między dwie otwarte listy.
    private static DefaultListModel model = null;

    private static DefaultListModel getModel()
    {
        if (model == null) {
            model = new DefaultListModel();
            for (Icon icon : FavoriteFolder.ICONS)
                model.addElement(icon);
        }
        return model;
    }

    //</editor-fold>
    private VNFileChooser chooser;
    private File folder;
    private JFrame frame;

    protected AddFavoriteFolderPanel(VNFileChooser chooser, File folder)
    {
        this.chooser = chooser;
        this.folder = folder;
        initComponents();
        initComponents2();
        frame = new JComponentViewer(this, "Add " + folder.getName() + " to favorites", 300, 200, false, false);
        frame.addWindowListener(new WindowAdapter()
        {
            @Override
            public void windowClosed(WindowEvent e)
            {
                dialogClosed();
            }
        });
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new JLabel();
        jScrollPane1 = new JScrollPane();
        iconList = new JList();
        nameField = new JTextField();
        jLabel2 = new JLabel();
        okButton = new JButton();
        cancelButton = new JButton();
        jLabel3 = new JLabel();
        pathField = new JTextField();

        jLabel1.setText("Name");
        jLabel1.setName("jLabel1"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        iconList.setModel(new AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };

            public int getSize() {
                return strings.length;
            }

            public Object getElementAt(int i) {
                return strings[i];
            }
        });
        iconList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        iconList.setLayoutOrientation(JList.HORIZONTAL_WRAP);
        iconList.setName("iconList"); // NOI18N
        iconList.setVisibleRowCount(-1);
        jScrollPane1.setViewportView(iconList);

        nameField.setText("Folder");
        nameField.setName("nameField"); // NOI18N

        jLabel2.setText("Icon");
        jLabel2.setName("jLabel2"); // NOI18N

        okButton.setText("OK");
        okButton.setName("okButton"); // NOI18N
        okButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.setName("cancelButton"); // NOI18N
        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel3.setText("Path");
        jLabel3.setName("jLabel3"); // NOI18N

        pathField.setText("Folder");
        pathField.setName("pathField"); // NOI18N

        GroupLayout layout = new GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(Alignment.LEADING)
                                        .addGroup(layout.createSequentialGroup()
                                                .addContainerGap()
                                                .addComponent(jLabel1)
                                                .addPreferredGap(ComponentPlacement.RELATED)
                                                .addComponent(nameField, GroupLayout.DEFAULT_SIZE, 329, Short.MAX_VALUE))
                                        .addGroup(layout.createSequentialGroup()
                                                .addGap(20, 20, 20)
                                                .addComponent(jLabel3)
                                                .addPreferredGap(ComponentPlacement.RELATED)
                                                .addComponent(pathField, GroupLayout.DEFAULT_SIZE, 329, Short.MAX_VALUE))
                                        .addGroup(Alignment.TRAILING, layout.createSequentialGroup()
                                                .addGap(21, 21, 21)
                                                .addGroup(layout.createParallelGroup(Alignment.LEADING)
                                                        .addGroup(layout.createSequentialGroup()
                                                                .addComponent(jLabel2)
                                                                .addPreferredGap(ComponentPlacement.RELATED)
                                                                .addComponent(jScrollPane1, GroupLayout.DEFAULT_SIZE, 329, Short.MAX_VALUE))
                                                        .addGroup(Alignment.TRAILING, layout.createSequentialGroup()
                                                                .addComponent(okButton, GroupLayout.PREFERRED_SIZE, 110, GroupLayout.PREFERRED_SIZE)
                                                                .addPreferredGap(ComponentPlacement.RELATED)
                                                                .addComponent(cancelButton)))))
                                .addContainerGap())
                );
        layout.setVerticalGroup(
                layout.createParallelGroup(Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(layout.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(jLabel1)
                                        .addComponent(nameField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(pathField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jLabel3))
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(Alignment.LEADING)
                                        .addComponent(jLabel2)
                                        .addComponent(jScrollPane1, GroupLayout.PREFERRED_SIZE, 90, GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(Alignment.BASELINE)
                                        .addComponent(okButton)
                                        .addComponent(cancelButton))
                                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                );
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        dialogClosed();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        FavoriteFolder ff = new FavoriteFolder(
            nameField.getText(),
            folder.getPath(),
            iconList.getSelectedIndex()
        );
        frame.setVisible(false);
        VisNow.get().getMainConfig().addFavoriteFolder(ff);
        chooser.updateFavoriteList();
    }//GEN-LAST:event_okButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JButton cancelButton;
    private JList iconList;
    private JLabel jLabel1;
    private JLabel jLabel2;
    private JLabel jLabel3;
    private JScrollPane jScrollPane1;
    private JTextField nameField;
    private JButton okButton;
    private JTextField pathField;

    // End of variables declaration//GEN-END:variables
    void showDialog()
    {
        nameField.setText(folder.getName());
        frame.setVisible(true);
    }

    private void dialogClosed()
    {
        frame.setVisible(false);
    }

    private void initComponents2()
    {
        iconList.setModel(getModel());
        iconList.setCellRenderer(new ListCellRenderer()
        {
            public Component getListCellRendererComponent(
                JList list,
                Object value,
                int index,
                boolean isSelected,
                boolean cellHasFocus)
            {
                JLabel lab;
                if (value instanceof Icon) {
                    lab = new JLabel();
                    lab.setIcon((Icon) value);
                } else {
                    lab = new JLabel("?");
                }
                if (isSelected) {
                    lab.setOpaque(true);
                    lab.setBackground(Color.LIGHT_GRAY);
                }
                return lab;
            }
        });
        iconList.setSelectedIndex(2);
    }

}
